;; This buffer is for notes you don't want to save, and for Lisp evaluation.
;; If you want to create a file, visit that file with C-x C-f,
;; then enter the text in that file's own buffer.

(defun sm-gcdi (a b)
  (let ((x a) (y b) r)
    (while (not (zerop y))
      (setq r (mod x y) x y y r))
    x))
(defun sm-gcdr (a b)
  (if (zerop b)
      a
    (sm-gcdr b (mod a b))))

(defun sm-test-iterative ()
  (let ((start (float-time)))
    (dotimes (_ 100000)
      (sm-gcdi 14472334024676221 8944394323791464))
    (- (float-time) start)))

(defun sm-test-recursive ()
  (let ((start (float-time)))
    (dotimes (_ 100000)
      (sm-gcdr 14472334024676221 8944394323791464))
    (- (float-time) start)))

(message "Interpreted:  Iterative=%.3fs; Recursive=%.3fs"
	 (sm-test-iterative) (sm-test-recursive))

(byte-compile 'sm-gcdi)
(byte-compile 'sm-gcdr)

(message "Bytecompiled: Iterative=%.3fs; Recursive=%.3fs"
	 (sm-test-iterative) (sm-test-recursive))
